SystemOrganization addCategory: #'Tropo-Kom'!

TPVoiceService subclass: #TPKomMakeCallJson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Kom'!

!TPKomMakeCallJson commentStamp: 'PaulDeBruicker 4/11/2011 11:15' prior: 0!
You can make telephone calls to numbers in the USA. 


This allows you to make telephone calls without using a hosted script which allows you to develop the back end of your application in smalltalk and just send tropo TropoML JSON objects.  


It also illustrates how to create and send TropoML JSON objects.  

How to set it up:


- Make an account on Tropo.  Add an application, set the URL to point to your server.  

-  Choose a port to listen on and either proxy the URL to that port, or just run it on port 80

- In TPVoiceService enter your Voice service token from tropo in the tropoToken method.

-  In a workspace run TPKomWaitForCall startOn: yourChosenPortNumber
	That starts an instance of Komanche listening on the port you choose and running TPKomWaitForCall class>>handleRequest: 
	when a request comes in.  


-  In a workspace do
		TPKomMakeCallJson  to: yourPhoneNumber withMessage: 'I sent a SMS message from smalltalk.'
		
		yourPhoneNumber must be in the usa, have the area code, and start with +1
		tropo will split the message into 160 character chunks at the nearest workd break if you're sending a long message.
		
	There are many more options you can set and you can script a conversation.  The docs on Tropo.com are good and the skeletons for the JSON objects are set up in this package.!

!TPKomMakeCallJson classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 17:01'!
to: aPhoneNumber withMessage: aString
	^self new say: aString to: aPhoneNumber ! !

!TPKomMakeCallJson methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 14:35'!
say: aString to: aPhoneNumber
	| x y json |
	self startNewSession
		ifTrue: [ 
			x := Dictionary new.
			y := Dictionary new.
			y
				at: 'message'
				put:
					((TPMessage new)
						to: aPhoneNumber;
						channel: 'VOICE';
						say: (TPSay new value: aString)).
			x at: 'tropo' put: y.
			json := x asJsonString.
			 TPVoiceService queueOutgoingCall:json ]! !

TPVoiceService subclass: #TPKomWaitForCall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Kom'!

TPKomWaitForCall class
	instanceVariableNames: 'httpService'!

TPKomWaitForCall class
	instanceVariableNames: 'httpService'!

!TPKomWaitForCall classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 18:57'!
handleRequest: aRequest
	| jsonData userType from conversation stream sessionId response |
	"should only be a POST from tropo"
"	self halt."
	aRequest isPostRequest
		ifTrue: [ 
			stream := aRequest stream.	
			jsonData := Json readFrom: stream.
	
			(jsonData at: 'session') notNil
				ifTrue: [ 
					from := (jsonData at: 'session') at: 'from'.
					sessionId := (jsonData at: 'session') at: 'id'.
					userType := (jsonData at: 'session') at: 'userType' ]
				ifFalse: [ sessionId := (jsonData at: 'result') at: 'sessionId' ].
			"	self halt."
			conversation := from isNil
				ifTrue: [ TPVoiceConversation findById: sessionId ]
				ifFalse: [ (TPVoiceConversation findByFrom: from) id: sessionId ].
			conversation requests add: jsonData.
			response := userType = 'NONE'
				ifTrue: [ TPVoiceService oldestOutgoingCall ]
				ifFalse: [ TPVoiceService findNextResponseFor: conversation. ].
			conversation responses add: response.
			"conversation printLastMessageToTranscipt."
			conversation inspect ].
		"self halt."
	^ HttpResponse fromString: response! !

!TPKomWaitForCall classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:55'!
httpService 
	^httpService ! !

!TPKomWaitForCall classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:55'!
httpService: anHttpService
	httpService:=anHttpService ! !

!TPKomWaitForCall classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 18:53'!
startOn: aPort
|ma authDb |
self stopOn: aPort.

"authDb := KomAuthDb new.
authDb addUser:'admin' withPassword:'seaside'."
ma :=ModuleAssembly core.
"ma authenticate: authDb realm:'sms'."
ma trackSessions .
ma sessionTimeout: 20.
ma addPlug:[:request| self handleRequest: request].
self httpService: (HttpService startOn: aPort named:'TPWaitForCall').
self httpService plug: ma rootModule.
self httpService setVerboseMode. ! !

!TPKomWaitForCall classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:55'!
stopOn: aPortNumber
HttpService allInstances do: [:eachService | eachService portNumber = aPortNumber ifTrue:[eachService unregister]].! !

TPSmsService subclass: #TPKomSendSmsJson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Kom'!

!TPKomSendSmsJson commentStamp: 'PaulDeBruicker 4/11/2011 11:13' prior: 0!
You can send sms messages to numbers in the USA. 


This allows you to send SMS messages without using a hosted script which allows you to develop the back end of your application in smalltalk and just send tropo TropoML JSON objects.  


It also illustrates how to create and send TropoML JSON objects.  

How to set it up:


- Make an account on Tropo.  Add an application, set the URL to point to your server.  

-  Choose a port to listen on and either proxy the URL to that port, or just run it on port 80

- In TPSmsService enter your Sms service token from tropo in the tropoToken method.

-  In a workspace run TPKomWaitForSms startOn: yourChosenPortNumber
	That starts an instance of Komanche listening on the port you choose and running TPKomWaitForSms class>>handleRequest: 
	when a request comes in.  


-  In a workspace do
		TPKomSendSmsJson  to: yourPhoneNumber withMessage: 'I sent a SMS message from smalltalk.'
		
		yourPhoneNumber must be in the usa, have the area code, and start with +1
		tropo will split the message into 160 character chunks at the nearest workd break if you're sending a long message.!

!TPKomSendSmsJson classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 11:00'!
to: aPhoneNumber withMessage: aString
	^self new sendSms: aString to: aPhoneNumber ! !

!TPKomSendSmsJson methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/11/2011 14:34'!
sendSms: aString to: aPhoneNumber
	| x y json |
	self startNewSession
		ifTrue: [ 
			x := Dictionary new.
			y := Dictionary new.
			y
				at: 'message'
				put:
					((TPMessage new)
						network: 'SMS';
						to: aPhoneNumber;
						channel: 'TEXT';
						say: (TPSay new value: aString)).
			x at: 'tropo' put: y.
			json := x asJsonString.
			 TPSmsService queueOutgoingMessage: json ]! !

TPSmsService subclass: #TPKomWaitForSms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Kom'!

TPKomWaitForSms class
	instanceVariableNames: 'httpService'!

!TPKomWaitForSms commentStamp: '<historical>' prior: 0!
Assumes Komanche webserver is installed.  

look at handleRequest: 




!

TPKomWaitForSms class
	instanceVariableNames: 'httpService'!

!TPKomWaitForSms classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/30/2010 11:03'!
handleRequest: aRequest
	| jsonData userType from conversation stream sessionId response |
	"should only be a POST from tropo"
	aRequest isPostRequest
		ifTrue: [ 
			stream := aRequest stream.	"self halt."
			jsonData := Json readFrom: stream.
			(jsonData at: 'session') notNil
				ifTrue: [ 
					from := (jsonData at: 'session') at: 'from'.
					sessionId := (jsonData at: 'session') at: 'id'.
					userType := (jsonData at: 'session') at: 'userType' ]
				ifFalse: [ sessionId := (jsonData at: 'result') at: 'sessionId' ].
			"	self halt."
			conversation := from isNil
				ifTrue: [ TPSmsConversation findById: sessionId ]
				ifFalse: [ (TPSmsConversation findByFrom: from) id: sessionId ].
			conversation requests add: jsonData.
			response := userType = 'NONE'
				ifTrue: [ TPSmsService oldestOutgoingMessage ]
				ifFalse: [ TPSmsService findNextResponseFor: conversation. ].
			conversation responses add: response.
		"	self halt."
			conversation from isNil
				ifFalse: [conversation printLastMessageToTranscipt].
			conversation inspect ].
	"	self halt."
	^ HttpResponse fromString: response! !

!TPKomWaitForSms classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:40'!
handleRequestJson: aRequest
	| jsonData userType from conversation stream sessionId response |
	"should only be a POST from tropo"
	aRequest isPostRequest
		ifTrue: [ 
			stream := aRequest stream.	"self halt."
			jsonData := Json readFrom: stream.
			(jsonData at: 'session') notNil
				ifTrue: [ 
					from := (jsonData at: 'session') at: 'from'.
					sessionId := (jsonData at: 'session') at: 'id'.
					userType := (jsonData at: 'session') at: 'userType' ]
				ifFalse: [ sessionId := (jsonData at: 'result') at: 'sessionId' ].
			"	self halt."
			conversation := from isNil
				ifTrue: [ TPSmsConversation findById: sessionId ]
				ifFalse: [ (TPSmsConversation findByFrom: from) id: sessionId ].
			conversation requests add: jsonData.
			response := userType = 'NONE'
				ifTrue: [ TPSmsService oldestOutgoingMessage ]
				ifFalse: [ TPSmsService findNextResponseFor: conversation. ].
			conversation responses add: response.
			"conversation printLastMessageToTranscipt."
			conversation inspect ].
	"	self halt."
	^ HttpResponse fromString: response! !

!TPKomWaitForSms classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/29/2010 16:40'!
handleRequestSimpleMessage: aRequest
	| to from msg fields conversation stream |
	"should only be a POST from tropo"


	aRequest isPostRequest
		ifTrue: [ 
			fields:=aRequest fields.
		msg:=TPMessage new.
		msg from: (fields at: 'from');
			to: (fields at: 'to');
			say: (fields at: 'msg').
		"	self halt."
			conversation := TPSmsConversation findByFrom: msg from.
			conversation messages add: msg.	
		"	self halt."
			conversation printLastMessageToTranscipt.
			conversation inspect.].
 ^HttpResponse fromString: '' ! !

!TPKomWaitForSms classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/27/2010 18:27'!
httpService 
	^httpService ! !

!TPKomWaitForSms classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/27/2010 18:28'!
httpService: anHttpService
	httpService:=anHttpService ! !

!TPKomWaitForSms classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/28/2010 11:28'!
startOn: aPort
|ma authDb |
self stopOn: aPort.

"authDb := KomAuthDb new.
authDb addUser:'admin' withPassword:'seaside'."
ma :=ModuleAssembly core.
"ma authenticate: authDb realm:'sms'."
ma trackSessions .
ma sessionTimeout: 20.
ma addPlug:[:request| self handleRequest: request].
self httpService: (HttpService startOn: aPort named:'TPWaitForSms').
self httpService plug: ma rootModule.
self httpService setVerboseMode. ! !

!TPKomWaitForSms classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/27/2010 20:40'!
stopOn: aPortNumber
HttpService allInstances do: [:eachService | eachService portNumber = aPortNumber ifTrue:[eachService unregister]].! !
